Summary: Apache secure password storage module
Name: mod_passwordstore
Version: 0.2
Release: 1%{?dist:%{dist}}
Group: System Environment/Daemons
URL: http://uranus.it.swin.edu.au/~jn/linux/php/passwords.htm
Source0: mod_passwordstore-%{version}.tgz
BuildPrereq: /usr/sbin/apxs
License: GPL
BuildRoot: %{_tmppath}/%{name}-root
Packager: John Newbign (jn@it.swin.edu.au)
Distribution: Premonition
Vendor: Premonition Software

%if "%{dist}" == ".el4"
# Do EL4 things
%endif

%description
This module loads a list of passwords at startup.  These passwords are only
made available to select directories, allowing php scripts to securely
retrieve passwords.

%prep
#%setup -n passwordstore
%setup

%build
#/usr/sbin/apxs -c -o mod_passwordstore.so mod_passwordstore.c
make
cp .libs/mod_passwordstore.so .

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%if "%{dist}" == ".el2"
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache/
cp mod_passwordstore.so $RPM_BUILD_ROOT/usr/lib/apache/

mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf/
echo "/sample:mysql:qwerty" > $RPM_BUILD_ROOT/etc/httpd/conf/passwords.txt

mkdir -p $RPM_BUILD_ROOT/var/www/html/sample/
cat >> $RPM_BUILD_ROOT/var/www/html/sample/index.php << END
<?php
virtual("/passwords");
\$password = apache_note("mysql");
echo \$password
?>
END
%else
mkdir -p $RPM_BUILD_ROOT/usr/lib/httpd/modules
cp mod_passwordstore.so $RPM_BUILD_ROOT/usr/lib/httpd/modules

mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d/
cp config/passwordstore.conf $RPM_BUILD_ROOT/etc/httpd/conf.d/
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf/
cp config/passwords.txt $RPM_BUILD_ROOT/etc/httpd/conf/

mkdir -p $RPM_BUILD_ROOT/var/www/html/sample/
cp config/index.php $RPM_BUILD_ROOT/var/www/html/sample/
%endif

%files 
%defattr(-,root,root)
%if "%{dist}" == ".el2"
/usr/lib/apache/mod_passwordstore.so
%else #.el3 .el4
/usr/lib/httpd/modules/mod_passwordstore.so
%config(noreplace) /etc/httpd/conf.d/passwordstore.conf
%endif
/var/www/html/sample/index.php

%defattr(0600,root,root)
%config(noreplace) /etc/httpd/conf/passwords.txt

%post
%if "%{dist}" == ".el2"
if [ x"$1" = x"1" ]; then
   # this is an install
   if grep -q "mod_passwordstore.so" /etc/httpd/conf/httpd.conf ; then
      # uncomment
      perl -pi -e 's|^#LoadModule passwordstore_module|LoadModule passwordstore_module|g' /etc/httpd/conf/httpd.conf
      perl -pi -e 's|^#AddModule mod_passwordstore.c|AddModule mod_passwordstore.c|g' /etc/httpd/conf/httpd.conf
   else
      # add the lines (with a patch)
      cd /etc/httpd/conf/
      patch << END
--- httpd.conf.orig     Mon Dec 13 10:54:53 2004
+++ httpd.conf  Mon Dec 13 10:56:29 2004
@@ -275,6 +275,7 @@
 <IfDefine HAVE_PYTHON>
 LoadModule python_module      modules/mod_python.so
 </IfDefine>
+LoadModule passwordstore_module        modules/mod_passwordstore.so

 #  Reconstruction of the complete module list from all available modules
 #  (static and shared ones) to achieve correct module execution order.
@@ -354,6 +355,7 @@
 <IfDefine HAVE_PYTHON>
 AddModule mod_python.c
 </IfDefine>
+AddModule mod_passwordstore.c

 #
 # ExtendedStatus controls whether Apache will generate "full" status
@@ -1128,6 +1130,13 @@
 #    Allow from .your_domain.com
 #</Location>

+<IfModule mod_passwordstore.c>
+    PasswordStoreFile /etc/httpd/conf/passwords.txt
+    <Location /passwords>
+        SetHandler passwords
+    </Location>
+</IfModule>
+
 #
 # Allow access to local system documentation from localhost
 #
END
   fi
#else
   # this is an upgrade
fi
%endif

%preun
%if "%{dist}" == ".el2"
if [ x"$1" = x"0" ]; then
   # uninstall
   perl -pi -e 's|^LoadModule passwordstore_module|#LoadModule passwordstore_module|g' /etc/httpd/conf/httpd.conf
   perl -pi -e 's|^AddModule mod_passwordstore.c|#AddModule mod_passwordstore.c|g' /etc/httpd/conf/httpd.conf
#else
   # upgrade
fi
%endif
